/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.JabatanDto;
import com.portofolio.service.JabatanService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;


@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/jabatan")
public class JabatanController extends LocaleController {
    @Lazy
	@Autowired
    private JabatanService jabatanService;
    
    
    @ApiOperation("Api Untuk Menyimpan Jabatan")
    @PostMapping("/save")
    public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody JabatanDto entity,HttpServletRequest request) {
        Map<String, Object> result = jabatanService.save(entity);
        return RestUtil.getJsonResponse(result);
    }
    
    @ApiOperation("Api Untuk Update Jabatan")
    @PutMapping("/update")
    public ResponseEntity<Map<String, Object>> update(
    		@RequestParam(value = "kdJabatan", required = true) String kdJabatan,
    		@RequestParam(value = "version", required = true) Integer version,
    		@Valid @RequestBody JabatanDto entity, HttpServletRequest request) {
        Map<String, Object> result = jabatanService.update(entity,kdJabatan,version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menghapus Jabatan Berdasarkan KdJabatan")
    @DeleteMapping("/delete")
    public ResponseEntity<Map<String, Object>> deleteById(
    		@RequestParam(value = "kdJabatan", required = true) String kdJabatan,
    		@RequestParam(value = "version", required = true) Integer version
    		) {
        Map<String, Object> result = jabatanService.deleteById(kdJabatan, version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Semua Jabatan")
    @GetMapping("/grid")
    public ResponseEntity<Map<String, Object>> grid(
    		@RequestParam(value = "page", defaultValue = "1") Integer page, 
    		@RequestParam(value = "rows", defaultValue = "10") Integer rows,			
    		@RequestParam(value = "dir", defaultValue = "namaJabatan") String dir,			
    		@RequestParam(value = "sort", defaultValue = "desc") String sort,			
    		@RequestParam(value = "namaJabatan", required = false) String namaJabatan,
    		@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
        Map<String, Object> result = jabatanService.grid(page, rows, sort, dir, namaJabatan,statusEnabled);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Jabatan Berdasarkan kdJabatan")
    @GetMapping("/findByKdJabatan")
    public ResponseEntity<Map<String, Object>> findByKdJabatan(
    		@RequestParam(value = "kdJabatan", required = true) String kdJabatan, 
    		HttpServletRequest request) {
        Map<String, Object> result = jabatanService.findByKdJabatan(kdJabatan);
        return RestUtil.getJsonResponse(result);
    }


}
